Represents a video call. It can also be seen as a videoconference room where multiple users can connect. Participants who publish their videos to a session can be seen by the rest of users connected to that specific session. Initialized with OpenVidu.initSession method

### Hierarchy

- Session

### Implements

- EventDispatcher

## Index

### Properties

- capabilities
- connection
- sessionId
- streamManagers

### Methods

- connect
- disconnect
- forceDisconnect
- forceUnpublish
- off
- on
- once
- publish
- signal
- subscribe
- subscribeAsync
- unpublish
- unsubscribe

## Properties

### capabilities

capabilities: Capabilities

- Defined in OpenVidu/Session.ts:71

Object defining the methods that the client is able to call. These are defined by the role of the token used to connect to the Session. This object is only defined after Session.connect has been successfully resolved

### connection

connection: Connection

- Defined in OpenVidu/Session.ts:55

Local connection to the Session. This object is defined only after Session.connect has been successfully executed, and can be retrieved subscribing to `connectionCreated` event

### sessionId

sessionId: string

- Defined in OpenVidu/Session.ts:60

Unique identifier of the Session

### streamManagers

streamManagers: StreamManager[] = []

- Defined in OpenVidu/Session.ts:65

Collection of all StreamManagers of this Session (Publisher and Subscriber)

## Methods

### connect

- connect(token: string): Promise<any>
- connect(token: string, metadata: any): Promise<any>

- - Defined in OpenVidu/Session.ts:105

  Connects to the session using `token`. Parameter `metadata` allows you to pass extra data to share with other users when they receive `streamCreated` event. The structure of `metadata` string is up to you (maybe some standarized format as JSON or XML is a good idea), the only restriction is a maximum length of 10000 chars.

  This metadata is not considered secure, as it is generated in the client side. To pass securized data, add it as a parameter in the token generation operation (through the API REST, openvidu-java-client or openvidu-node-client).

  Only after the returned Promise is successfully resolved Session.connection object will be available and properly defined.

  #### Events dispatched

  The Session object of the local participant will first dispatch one or more `connectionCreated` events upon successful termination of this method:

  - First one for your own local Connection object, so you can retrieve Session.connection property.
  - Then one for each remote Connection previously connected to the Session, if any. Any other remote user connecting to the Session after you have successfully connected will also dispatch a `connectionCreated` event when they do so.

  The Session object of the local participant will also dispatch a `streamCreated` event for each remote active Publisher that was already streaming when connecting, just after dispatching all remote `connectionCreated` events.

  The Session object of every other participant connected to the session will dispatch a `connectionCreated` event.

  See ConnectionEvent and StreamEvent to learn more.

  #### Parameters

  - ##### token: string

  #### Returns Promise<any>

  A Promise to which you must subscribe that is resolved if the the connection to the Session was successful and rejected with an Error object if not

- - Defined in OpenVidu/Session.ts:106

  Connects to the session using `token`. Parameter `metadata` allows you to pass extra data to share with other users when they receive `streamCreated` event. The structure of `metadata` string is up to you (maybe some standarized format as JSON or XML is a good idea), the only restriction is a maximum length of 10000 chars.

  This metadata is not considered secure, as it is generated in the client side. To pass securized data, add it as a parameter in the token generation operation (through the API REST, openvidu-java-client or openvidu-node-client).

  Only after the returned Promise is successfully resolved Session.connection object will be available and properly defined.

  #### Events dispatched

  The Session object of the local participant will first dispatch one or more `connectionCreated` events upon successful termination of this method:

  - First one for your own local Connection object, so you can retrieve Session.connection property.
  - Then one for each remote Connection previously connected to the Session, if any. Any other remote user connecting to the Session after you have successfully connected will also dispatch a `connectionCreated` event when they do so.

  The Session object of the local participant will also dispatch a `streamCreated` event for each remote active Publisher that was already streaming when connecting, just after dispatching all remote `connectionCreated` events.

  The Session object of every other participant connected to the session will dispatch a `connectionCreated` event.

  See ConnectionEvent and StreamEvent to learn more.

  #### Parameters

  - ##### token: string

  - ##### metadata: any

  #### Returns Promise<any>

  A Promise to which you must subscribe that is resolved if the the connection to the Session was successful and rejected with an Error object if not

### disconnect

- disconnect(): void

- - Defined in OpenVidu/Session.ts:185

  Leaves the session, destroying all streams and deleting the user as a participant.

  #### Events dispatched

  The Session object of the local participant will dispatch a `sessionDisconnected` event. This event will automatically unsubscribe the leaving participant from every Subscriber object of the session (this includes closing the WebRTCPeer connection and disposing all MediaStreamTracks) and also deletes any HTML video element associated to each Subscriber (only those created by OpenVidu Browser). For every video removed, each Subscriber object will dispatch a `videoElementDestroyed` event. Call `event.preventDefault()` upon event `sessionDisconnected` to avoid this behavior and take care of disposing and cleaning all the Subscriber objects yourself. See SessionDisconnectedEvent and VideoElementEvent to learn more to learn more.

  The Publisher object of the local participant will dispatch a `streamDestroyed` event if there is a Publisher object publishing to the session. This event will automatically stop all media tracks and delete any HTML video element associated to it (only those created by OpenVidu Browser). For every video removed, the Publisher object will dispatch a `videoElementDestroyed` event. Call `event.preventDefault()` upon event `streamDestroyed` if you want to clean the Publisher object on your own or re-publish it in a different Session (to do so it is a mandatory requirement to call `Session.unpublish()` or/and `Session.disconnect()` in the previous session). See StreamEvent and VideoElementEvent to learn more.

  The Session object of every other participant connected to the session will dispatch a `streamDestroyed` event if the disconnected participant was publishing. This event will automatically unsubscribe the Subscriber object from the session (this includes closing the WebRTCPeer connection and disposing all MediaStreamTracks) and also deletes any HTML video element associated to that Subscriber (only those created by OpenVidu Browser). For every video removed, the Subscriber object will dispatch a `videoElementDestroyed` event. Call `event.preventDefault()` upon event `streamDestroyed` to avoid this default behavior and take care of disposing and cleaning the Subscriber object yourself. See StreamEvent and VideoElementEvent to learn more.

  The Session object of every other participant connected to the session will dispatch a `connectionDestroyed` event in any case. See ConnectionEvent to learn more.

  #### Returns void

### forceDisconnect

- forceDisconnect(connection: Connection): Promise<any>

- - Defined in OpenVidu/Session.ts:433

  Forces some user to leave the session

  #### Events dispatched

  The behavior is the same as when some user calls Session.disconnect, but `reason` property in all events will be `"forceDisconnectByUser"`.

  The Session object of every participant will dispatch a `streamDestroyed` event if the evicted user was publishing a stream, with property `reason` set to `"forceDisconnectByUser"`. The Session object of every participant except the evicted one will dispatch a `connectionDestroyed` event for the evicted user, with property `reason` set to `"forceDisconnectByUser"`.

  If any, the Publisher object of the evicted participant will also dispatch a `streamDestroyed` event with property `reason` set to `"forceDisconnectByUser"`. The Session object of the evicted participant will dispatch a `sessionDisconnected` event with property `reason` set to `"forceDisconnectByUser"`.

  See StreamEvent, ConnectionEvent and SessionDisconnectedEvent to learn more.

  #### Parameters

  - ##### connection: Connection

  #### Returns Promise<any>

  A Promise (to which you can optionally subscribe to) that is resolved only after the participant has been successfully evicted from the session and rejected with an Error object if not

### forceUnpublish

- forceUnpublish(stream: Stream): Promise<any>

- - Defined in OpenVidu/Session.ts:472

  Forces some user to unpublish a Stream

  #### Events dispatched

  The behavior is the same as when some user calls Session.unpublish, but `reason` property in all events will be `"forceUnpublishByUser"`

  The Session object of every participant will dispatch a `streamDestroyed` event with property `reason` set to `"forceDisconnectByUser"`

  The Publisher object of the affected participant will also dispatch a `streamDestroyed` event with property `reason` set to `"forceDisconnectByUser"`

  See StreamEvent to learn more.

  #### Parameters

  - ##### stream: Stream

  #### Returns Promise<any>

  A Promise (to which you can optionally subscribe to) that is resolved only after the remote Stream has been successfully unpublished from the session and rejected with an Error object if not

### off

- off(type: string, handler?: function): Session

- - Defined in OpenVidu/Session.ts:602

  See EventDispatcher.off

  #### Parameters

  - ##### type: string

  - ##### Optional handler: function

    - - (event: SessionDisconnectedEvent | SignalEvent | StreamEvent | ConnectionEvent | PublisherSpeakingEvent | RecordingEvent): void

      - #### Parameters

        - ##### event: SessionDisconnectedEvent | SignalEvent | StreamEvent | ConnectionEvent | PublisherSpeakingEvent | RecordingEvent

        #### Returns void

  #### Returns Session

### on

- on(type: string, handler: function): EventDispatcher

- - Defined in OpenVidu/Session.ts:544

  See EventDispatcher.on

  #### Parameters

  - ##### type: string

  - ##### handler: function

    - - (event: SessionDisconnectedEvent | SignalEvent | StreamEvent | ConnectionEvent | PublisherSpeakingEvent | RecordingEvent): void

      - #### Parameters

        - ##### event: SessionDisconnectedEvent | SignalEvent | StreamEvent | ConnectionEvent | PublisherSpeakingEvent | RecordingEvent

        #### Returns void

  #### Returns EventDispatcher

### once

- once(type: string, handler: function): Session

- - Defined in OpenVidu/Session.ts:573

  See EventDispatcher.once

  #### Parameters

  - ##### type: string

  - ##### handler: function

    - - (event: SessionDisconnectedEvent | SignalEvent | StreamEvent | ConnectionEvent | PublisherSpeakingEvent | RecordingEvent): void

      - #### Parameters

        - ##### event: SessionDisconnectedEvent | SignalEvent | StreamEvent | ConnectionEvent | PublisherSpeakingEvent | RecordingEvent

        #### Returns void

  #### Returns Session

### publish

- publish(publisher: Publisher): Promise<any>

- - Defined in OpenVidu/Session.ts:328

  Publishes to the Session the Publisher object

  #### Events dispatched

  The local Publisher object will dispatch a `streamCreated` event upon successful termination of this method. See StreamEvent to learn more.

  The local Publisher object will dispatch a `streamPlaying` once the media stream starts playing. See StreamManagerEvent to learn more.

  The Session object of every other participant connected to the session will dispatch a `streamCreated` event so they can subscribe to it. See StreamEvent to learn more.

  #### Parameters

  - ##### publisher: Publisher

  #### Returns Promise<any>

  A Promise (to which you can optionally subscribe to) that is resolved only after the publisher was successfully published and rejected with an Error object if not

### signal

- signal(signal: SignalOptions): Promise<any>

- - Defined in OpenVidu/Session.ts:508

  Sends one signal. `signal` object has the following optional properties:

      {data:string, to:Connection[], type:string}

  All users subscribed to that signal (`session.on('signal:type', ...)` or `session.on('signal', ...)` for all signals) and whose Connection objects are in `to` array will receive it. Their local Session objects will dispatch a `signal` or `signal:type` event. See SignalEvent to learn more.

  #### Parameters

  - ##### signal: SignalOptions

  #### Returns Promise<any>

  A Promise (to which you can optionally subscribe to) that is resolved if the message successfully reached openvidu-server and rejected with an Error object if not. This doesn't mean that openvidu-server could resend the message to all the listed receivers.

### subscribe

- subscribe(stream: Stream, targetElement: string | HTMLElement): Subscriber
- subscribe(stream: Stream, targetElement: string | HTMLElement, properties: SubscriberProperties): Subscriber
- subscribe(stream: Stream, targetElement: string | HTMLElement, completionHandler: function): Subscriber
- subscribe(stream: Stream, targetElement: string | HTMLElement, properties: SubscriberProperties, completionHandler: function): Subscriber

- - Defined in OpenVidu/Session.ts:189

  Subscribes to a `stream`, adding a new HTML video element to DOM with `subscriberProperties` settings. This method is usually called in the callback of `streamCreated` event.

  #### Events dispatched

  The Subscriber object will dispatch a `videoElementCreated` event once the HTML video element has been added to DOM (only if you let OpenVidu take care of the video players). See VideoElementEvent to learn more.

  The Subscriber object will dispatch a `streamPlaying` event once the remote stream starts playing. See StreamManagerEvent to learn more.

  #### Parameters

  - ##### stream: Stream

    Stream object to subscribe to

  - ##### targetElement: string | HTMLElement

    HTML DOM element (or its `id` attribute) in which the video element of the Subscriber will be inserted (see SubscriberProperties.insertMode). If null or undefined no default video will be created for this Subscriber. You can always call method Subscriber.addVideoElement or Subscriber.createVideoElement to manage the video elements on your own (see Manage video players section)

  #### Returns Subscriber

- - Defined in OpenVidu/Session.ts:190

  Subscribes to a `stream`, adding a new HTML video element to DOM with `subscriberProperties` settings. This method is usually called in the callback of `streamCreated` event.

  #### Events dispatched

  The Subscriber object will dispatch a `videoElementCreated` event once the HTML video element has been added to DOM (only if you let OpenVidu take care of the video players). See VideoElementEvent to learn more.

  The Subscriber object will dispatch a `streamPlaying` event once the remote stream starts playing. See StreamManagerEvent to learn more.

  #### Parameters

  - ##### stream: Stream

    Stream object to subscribe to

  - ##### targetElement: string | HTMLElement

    HTML DOM element (or its `id` attribute) in which the video element of the Subscriber will be inserted (see SubscriberProperties.insertMode). If null or undefined no default video will be created for this Subscriber. You can always call method Subscriber.addVideoElement or Subscriber.createVideoElement to manage the video elements on your own (see Manage video players section)

  - ##### properties: SubscriberProperties

  #### Returns Subscriber

- - Defined in OpenVidu/Session.ts:191

  Subscribes to a `stream`, adding a new HTML video element to DOM with `subscriberProperties` settings. This method is usually called in the callback of `streamCreated` event.

  #### Events dispatched

  The Subscriber object will dispatch a `videoElementCreated` event once the HTML video element has been added to DOM (only if you let OpenVidu take care of the video players). See VideoElementEvent to learn more.

  The Subscriber object will dispatch a `streamPlaying` event once the remote stream starts playing. See StreamManagerEvent to learn more.

  #### Parameters

  - ##### stream: Stream

    Stream object to subscribe to

  - ##### targetElement: string | HTMLElement

    HTML DOM element (or its `id` attribute) in which the video element of the Subscriber will be inserted (see SubscriberProperties.insertMode). If null or undefined no default video will be created for this Subscriber. You can always call method Subscriber.addVideoElement or Subscriber.createVideoElement to manage the video elements on your own (see Manage video players section)

  - ##### completionHandler: function

    `error` parameter is null if `subscribe` succeeds, and is defined if it fails.

    - - (error: Error | undefined): void

      - #### Parameters

        - ##### error: Error | undefined

        #### Returns void

  #### Returns Subscriber

- - Defined in OpenVidu/Session.ts:192

  Subscribes to a `stream`, adding a new HTML video element to DOM with `subscriberProperties` settings. This method is usually called in the callback of `streamCreated` event.

  #### Events dispatched

  The Subscriber object will dispatch a `videoElementCreated` event once the HTML video element has been added to DOM (only if you let OpenVidu take care of the video players). See VideoElementEvent to learn more.

  The Subscriber object will dispatch a `streamPlaying` event once the remote stream starts playing. See StreamManagerEvent to learn more.

  #### Parameters

  - ##### stream: Stream

    Stream object to subscribe to

  - ##### targetElement: string | HTMLElement

    HTML DOM element (or its `id` attribute) in which the video element of the Subscriber will be inserted (see SubscriberProperties.insertMode). If null or undefined no default video will be created for this Subscriber. You can always call method Subscriber.addVideoElement or Subscriber.createVideoElement to manage the video elements on your own (see Manage video players section)

  - ##### properties: SubscriberProperties

  - ##### completionHandler: function

    `error` parameter is null if `subscribe` succeeds, and is defined if it fails.

    - - (error: Error | undefined): void

      - #### Parameters

        - ##### error: Error | undefined

        #### Returns void

  #### Returns Subscriber

### subscribeAsync

- subscribeAsync(stream: Stream, targetElement: string | HTMLElement): Promise<Subscriber>
- subscribeAsync(stream: Stream, targetElement: string | HTMLElement, properties: SubscriberProperties): Promise<Subscriber>

- - Defined in OpenVidu/Session.ts:257

  Promisified version of Session.subscribe

  #### Parameters

  - ##### stream: Stream

  - ##### targetElement: string | HTMLElement

  #### Returns Promise<Subscriber>

- - Defined in OpenVidu/Session.ts:258

  #### Parameters

  - ##### stream: Stream

  - ##### targetElement: string | HTMLElement

  - ##### properties: SubscriberProperties

  #### Returns Promise<Subscriber>

### unpublish

- unpublish(publisher: Publisher): void

- - Defined in OpenVidu/Session.ts:383

  Unpublishes from the Session the Publisher object.

  #### Events dispatched

  The Publisher object of the local participant will dispatch a `streamDestroyed` event. This event will automatically stop all media tracks and delete any HTML video element associated to this Publisher (only those videos created by OpenVidu Browser). For every video removed, the Publisher object will dispatch a `videoElementDestroyed` event. Call `event.preventDefault()` upon event `streamDestroyed` if you want to clean the Publisher object on your own or re-publish it in a different Session.

  The Session object of every other participant connected to the session will dispatch a `streamDestroyed` event. This event will automatically unsubscribe the Subscriber object from the session (this includes closing the WebRTCPeer connection and disposing all MediaStreamTracks) and delete any HTML video element associated to it (only those created by OpenVidu Browser). For every video removed, the Subscriber object will dispatch a `videoElementDestroyed` event. Call `event.preventDefault()` upon event `streamDestroyed` to avoid this default behavior and take care of disposing and cleaning the Subscriber object on your own.

  See StreamEvent and VideoElementEvent to learn more.

  #### Parameters

  - ##### publisher: Publisher

  #### Returns void

### unsubscribe

- unsubscribe(subscriber: Subscriber): void

- - Defined in OpenVidu/Session.ts:293

  Unsubscribes from `subscriber`, automatically removing its associated HTML video elements.

  #### Events dispatched

  The Subscriber object will dispatch a `videoElementDestroyed` event for each video associated to it that was removed from DOM. Only videos created by OpenVidu Browser) will be automatically removed

  See VideoElementEvent to learn more

  #### Parameters

  - ##### subscriber: Subscriber

  #### Returns void

Generated using TypeDoc